Symbol - Crystal 1.21.0

# struct Symbol

- Symbol
- Value
- Object

##
Overview

A symbol is a constant that is identified by a name without you having to give it a numeric value.

    :hello
    :welcome
    :"123"
    :"symbol with spaces"

See `Symbol` literals in the language reference.

Internally a symbol is represented as an `Int32`, so it's very efficient.

You can't dynamically create symbols. When you compile your program, each symbol gets assigned a unique number.

##
Included Modules

- Comparable(Symbol)

##
Defined in:

json/to_json.cr
primitives.cr
symbol.cr
yaml/to_yaml.cr

##
Class Method Summary

- .needs_quotes?(string) : Bool

  Determines if a string needs to be quoted to be used for a symbol literal.

##
Instance Method Summary

- #!=(other : Symbol) : Bool

  Returns `true` if `self` is not equal to other.

- #<=>(other : Symbol)

  Compares symbol with other based on `String#<=>` method.

- #==(other : Symbol) : Bool

  Returns `true` if `self` is equal to other.

- #clone
- #hash(hasher)

  See `Object#hash(hasher)`

- #inspect(io : IO) : Nil

  Returns the symbol literal representation as a string.

- #to_i : Int32

  Returns a unique number for this symbol.

- #to_json(json : JSON::Builder) : Nil
- #to_json_object_key : String
- #to_s(io : IO) : Nil

  Appends the symbol's name to the passed `IO`.

- #to_s : String

  Returns the symbol's name as a String.

- #to_yaml(yaml : YAML::Nodes::Builder) : Nil

### Instance methods inherited from module `Comparable(Symbol)`

<(other : T) : Bool <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) : Bool >, >=(other : T) >=, clamp(min, max)
clamp(range : Range) clamp

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Class Method Detail

def self.needs_quotes?(string) : Bool #

Determines if a string needs to be quoted to be used for a symbol literal.

    Symbol.needs_quotes? "string"      # => false
    Symbol.needs_quotes? "long string" # => true

##
Instance Method Detail

def !=(other : Symbol) : Bool #

Returns `true` if `self` is not equal to other.

def <=>(other : Symbol) #

Compares symbol with other based on `String#<=>` method. Returns `-1`, `0` or `1` depending on whether symbol is less than, equal to, or greater than other.

See `String#<=>` for more information.

def ==(other : Symbol) : Bool #

Returns `true` if `self` is equal to other.

def clone #
def hash(hasher) #

See `Object#hash(hasher)`

def inspect(io : IO) : Nil #

Returns the symbol literal representation as a string.

    :crystal.inspect # => ":crystal"

def to_i : Int32 #

Returns a unique number for this symbol.

def to_json(json : JSON::Builder) : Nil #
def to_json_object_key : String #
def to_s(io : IO) : Nil #

Appends the symbol's name to the passed `IO`.

    :crystal.to_s # => "crystal"

def to_s : String #

Returns the symbol's name as a String.

    :foo.to_s           # => "foo"
    :"hello world".to_s # => "hello world"

def to_yaml(yaml : YAML::Nodes::Builder) : Nil #